"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _weakMap = require("babel-runtime/core-js/weak-map");

var _weakMap2 = _interopRequireDefault(_weakMap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @private
 * @type {WeakMap}
 */
const OPTIONS_RESOLVER = new _weakMap2.default();

/**
 * @class
 */
class ConfigCommand {
  /**
   * @constructor
   * @param {ConfigOptionsResolver} optionsResolver
   */
  constructor(optionsResolver) {
    OPTIONS_RESOLVER.set(this, optionsResolver);
  }

  /**
   * @abstract
   * @param {Config} config
   * @param {ConfigOptions} options
   * @returns {void}
   */
  execute(config, options) {} // eslint-disable-line no-unused-vars

  /**
   * @type {ConfigOptionsResolver}
   */
  get optionsResolver() {
    return OPTIONS_RESOLVER.get(this);
  }
}

exports.default = ConfigCommand;
module.exports = exports["default"];
//# sourceMappingURL=ConfigCommand.js.map