'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

/**
 * @private
 * @type {String}
 */
const MODULE_PREFIX = 'webpack-config';

exports.default = [
/**
 * @example `require('<module-name>')`
 * @param {String} value
 * @throws {Error}
 * @returns {String}
 */
value => require.resolve(value),

/**
 * @example `require('webpack-config-<name>')`
 * @param {String} value
 * @throws {Error}
 * @returns {String}
 */
value => require.resolve(`${MODULE_PREFIX}-${value}`),

/**
 * @example `path.resolve('<file-name>')`
 * @param {String} value
 * @returns {String}
 */
value => (0, _path.resolve)(value)];
module.exports = exports['default'];
//# sourceMappingURL=ConfigPathResolvers.js.map